/* Sistemas Integrados TEKNISA

Nome: 4200_GRSSTPO_EXPORTA_TABELA_TI.SQL

C:\web_542\sql\end_conv\oracle\clientes\grs\4200_GRSSTPO_EXPORTA_TABELA_TI.SQL

Descrio:
Rotina para gravao das informaes do TI na tabela EXPORTACAOTI

Criao:
20/01/2010 - Cleison Rafael da Silva Ferreira
*/

CREATE OR REPLACE PROCEDURE EXPORTA_TABELA_TI
(
   P_CDFILIAL   IN   NOTAFISCAL.CDFILIAL%TYPE,
   P_DTFINAL    IN   NOTAFISCAL.DTENTRSAID%TYPE
)
AS
BEGIN
   DELETE FROM EXPORTACAOTI
    WHERE CDFILIAL2TI = P_CDFILIAL
      AND TO_CHAR(TO_DATE(DTCONTABILTI,'YYYYMMDD'),'YYYYMM') = TO_CHAR(P_DTFINAL,'YYYYMM');

   FOR C_TI IN (SELECT NVL(F.CDEMPRESA,'  ') AS CDEMPRESATI,
                       LPAD(DECODE(A.IDTIPODADOTG,'L',NVL(SUBSTR(PE.CDLOCALESTOQ,DECODE(LENGTH(PE.CDLOCALESTOQ),6,3,5,2,1),4),'    '),'A',NVL(SUBSTR(PE.CDALMOXARIFE,
                       DECODE(LENGTH(PE.CDALMOXARIFE),6,3,5,2,1),4),'    ') ,NVL(F.CDFILIAL,'    ')),4,' ') AS CDFILIALTI,
                       '9' || TO_CHAR(P_DTFINAL,'MM') || '0' AS NRNUMERORETI,
                       TO_CHAR(P_DTFINAL,'YYYYMMDD') AS DTCONTABILTI,
                       NVL(F.CDFILIAL,'    ') AS CDFILIAL2TI,
                       'J' AS FIXO2TI,
                       RPAD(NVL(F.NRINSJURFILI,'              '),14,' ') AS INSCRICAOTI,
                       RPAD(NVL(NVL(PE.CDPRODINTE,PE.CDARVPROD),'          '),10,' ') AS PRODUTOTI,
                       ROUND(PE.QTESTOQDIA,4) AS QUANTIDADETI,
                       ROUND(PE.VRESTOQDIA,4) AS VRUNITARIOTI,
                       ROUND(PET.VRESTOQDIATOT,4) AS VRESTOQTI
                  FROM FILIAL F, NOVOCODIGO N, PARAMFILIAL A,
                       (SELECT P.CDFILIAL,       P.CDALMOXARIFE,  P.CDLOCALESTOQ,
                               NVL(P.NRLOTEESTQ,' ') NRLOTEESTQ,  NVL(P.NRSUBLOTE,' ') NRSUBLOTE,
                               PROD.CDPRODINTE,      P.CDPRODUTO, CDARVPROD,  SUM(P.QTESTOQDIA) QTESTOQDIA,
                               SUM(P.VRESTOQBRUT) VRESTOQDIA, SUM(P.VRESTOQBRUT) VRESTOQBRUT
                          FROM POSESTDIA P, PRODUTO PROD
                         WHERE (P.CDFILIAL  = P_CDFILIAL)                                        AND
                               (P.CDPRODUTO = PROD.CDPRODUTO)                                    AND
                               (PROD.CDPRODUTO = PROD.CDPRODESTO)                                AND
                               (P.QTESTOQDIA <> 0)                                               AND
                               (P.DTPOSIESTQ = (SELECT MAX(C.DTPOSIESTQ)
                                                  FROM POSESTDIA C
                                                 WHERE (C.CDFILIAL     = P.CDFILIAL)      AND
                                                       (C.CDPRODUTO    = P.CDPRODUTO)     AND
                                                       (C.CDALMOXARIFE = P.CDALMOXARIFE)  AND
                                                       (C.CDLOCALESTOQ = P.CDLOCALESTOQ)  AND
                                                       (C.NRLOTEESTQ   = P.NRLOTEESTQ)    AND
                                                       (C.NRSUBLOTE    = P.NRSUBLOTE)     AND
                                                       (C.DTPOSIESTQ <= TO_DATE(P_DTFINAL + 1))))
                         GROUP BY P.CDFILIAL,   P.CDALMOXARIFE, P.CDLOCALESTOQ,
                                P.NRLOTEESTQ, P.NRSUBLOTE,    PROD.CDPRODINTE, P.CDPRODUTO, PROD.CDARVPROD) PE,
                       (SELECT SUM(P1.VRESTOQBRUT) VRESTOQDIATOT, P1.CDFILIAL, P1.CDALMOXARIFE, P1.CDLOCALESTOQ, NVL(P1.NRLOTEESTQ,' ') NRLOTEESTQ,
                               NVL(P1.NRSUBLOTE,' ') NRSUBLOTE
                          FROM POSESTDIA P1, PRODUTO PROD
                         WHERE  (P1.CDFILIAL  =  P_CDFILIAL)                                AND
                                (P1.CDPRODUTO = PROD.CDPRODUTO)                             AND
                                (PROD.CDPRODUTO = PROD.CDPRODESTO)                          AND
                                (P1.QTESTOQDIA <> 0)                                        AND
                                (P1.DTPOSIESTQ = (SELECT MAX(B.DTPOSIESTQ)
                                                    FROM POSESTDIA B
                                                   WHERE (B.CDFILIAL     = P1.CDFILIAL)       AND
                                                         (B.CDPRODUTO    = P1.CDPRODUTO)      AND
                                                         (B.CDALMOXARIFE = P1.CDALMOXARIFE)   AND
                                                         (B.CDLOCALESTOQ = P1.CDLOCALESTOQ)   AND
                                                         (B.NRLOTEESTQ   = P1.NRLOTEESTQ)     AND
                                                         (B.NRSUBLOTE    = P1.NRSUBLOTE)      AND
                                                         (B.DTPOSIESTQ <= TO_DATE(P_DTFINAL + 1))))
                         GROUP BY P1.CDFILIAL, P1.CDALMOXARIFE, P1.CDLOCALESTOQ, P1.NRLOTEESTQ, P1.NRSUBLOTE) PET
                 WHERE PE.CDFILIAL      = F.CDFILIAL AND
                       PE.CDFILIAL      = A.CDFILIAL AND
                       N.CDCONTADOR(+)  = 'RENOTAFISCAL'||PE.CDFILIAL  AND
                       PE.CDFILIAL      = PET.CDFILIAL                 AND
                       PE.CDALMOXARIFE  = PET.CDALMOXARIFE             AND
                       PE.CDLOCALESTOQ  = PET.CDLOCALESTOQ             AND
                       PE.NRLOTEESTQ    = PET.NRLOTEESTQ               AND
                       PE.NRSUBLOTE     = PET.NRSUBLOTE) LOOP

      INSERT INTO EXPORTACAOTI
        (CDEMPRESATI, CDFILIALTI, NRNUMERORETI, DTCONTABILTI,
         CDFILIAL2TI, FIXO2TI, INSCRICAOTI, PRODUTOTI,
         QUANTIDADETI, VRUNITARIOTI, VRESTOQTI)
      VALUES
        (C_TI.CDEMPRESATI, C_TI.CDFILIALTI, C_TI.NRNUMERORETI, C_TI.DTCONTABILTI,
         C_TI.CDFILIAL2TI, C_TI.FIXO2TI, C_TI.INSCRICAOTI, C_TI.PRODUTOTI,
         C_TI.QUANTIDADETI, C_TI.VRUNITARIOTI, C_TI.VRESTOQTI);

   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_TABELA_TI','5.42.XXX'); END;
/
