const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const modeloDocumentoFiscalPage = require('../../../page-objects/parametrizacao/documentos fiscais/modeloDocumentoFiscal.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela Modelo de Documento Fiscal', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        modeloDocumentoFiscalPage.abrir();
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Acessar a tela Modelo de Documento Fiscal', () => {
        expect(z.component.header.getTitle()).toBe('Modelo de Documento Fiscal');
    });

    it('Adicionar Modelo de Documento 21', () => {
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocumento(j.getValor('cdmoddocfisc21'), j.getValor('dsmoddocfisc21'), j.getValor('idmoddocnfen'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc21'));
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc21'), 1)).toBe(j.getValor('dsmoddocfisc21'));
    });

    it('Adicionar Modelo de Documento 59', () => {
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocumento(j.getValor('cdmoddocfisc59'), j.getValor('dsmoddocfisc59'), j.getValor('idmoddocnfen'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc59'));
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc59'), 1)).toBe(j.getValor('dsmoddocfisc59'));
    });

    it('Adicionar Modelo de Documento 67', () => {
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocumento(j.getValor('cdmoddocfisc67'), j.getValor('dsmoddocfisc67'), j.getValor('idmoddocnfes'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc67'));
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc67'), 1)).toBe(j.getValor('dsmoddocfisc67'));
    });

    it('Editar Modelo de documento 55', () => {
        geralPage.filterIt(j.getValor('dsmoddocfisc5'));
        geralPage.clickGrid('DSMODDOCFISC', j.getValor('dsmoddocfisc5'), '4860662821057106891013', false);
        geralPage.clickEditar();
        modeloDocumentoFiscalPage.editarModeloDocumento(j.getValor('dsmoddocfisc55'), j.getValor('idmoddocnfes'));
        geralPage.clickSalvar();
        geralPage.clickVoltar();
        geralPage.filterIt(j.getValor('dsmoddocfisc55'));
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc55'), 1)).toBe(j.getValor('dsmoddocfisc55'));
    });

    it('Editar Modelo de documento 65', () => {
        geralPage.filterIt(j.getValor('dsmoddocfisc6'));
        geralPage.clickGrid('DSMODDOCFISC', j.getValor('dsmoddocfisc6'), '4860662821057106891013', false);
        geralPage.clickEditar();
        modeloDocumentoFiscalPage.editarModeloDocumento(j.getValor('dsmoddocfisc65'), j.getValor('idmoddocnfes'));
        geralPage.clickSalvar();
        geralPage.clickVoltar();
        geralPage.filterIt(j.getValor('dsmoddocfisc65'));
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc65'), 1)).toBe(j.getValor('dsmoddocfisc65'));
    });

    it('Excluir Modelod e Documento 21', () => {
        geralPage.filterIt(j.getValor('dsmoddocfisc21'));
        geralPage.clickGrid('DSMODDOCFISC', j.getValor('dsmoddocfisc21'), '4860662821057106891013', false);
        modeloDocumentoFiscalPage.excluirModeloDocumento();
        expect(geralPage.gridHasText('4860662821057106891013', j.getValor('dsmoddocfisc21'), 1, false)).toBeUndefined();
    });

    it('Adicionar Modelo de Documento por Operação Entrada', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocOper(j.getValor('identrsaidop01'), j.getValor('nmtipooper01'), j.getValor('dsmoddocfisc59'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc59'));
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc59'), 1)).toBe(j.getValor('dsmoddocfisc59'));
    });

    it('Adicionar Modelo de Documento por Operação Entrada', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocOper(j.getValor('identrsaidop01'), j.getValor('nmtipooper01'), j.getValor('dsmoddocfisc65'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc65'));
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc65'), 1)).toBe(j.getValor('dsmoddocfisc65'));
    });

    it('Adicionar Modelo de Documento por Operação Saída', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocOper(j.getValor('identrsaidop02'), j.getValor('nmtipooper02'), j.getValor('dsmoddocfisc59'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc59'));
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc59'), 1)).toBe(j.getValor('dsmoddocfisc59'));
    });

    it('Adicionar Modelo de Documento por Operação Saída', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocOper(j.getValor('identrsaidop02'), j.getValor('nmtipooper02'), j.getValor('dsmoddocfisc65'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc65'));
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc65'), 1)).toBe(j.getValor('dsmoddocfisc65'));
    });

    it('Adicionar Modelo de Documento por Operação Saída', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        geralPage.clickAdicionar();
        modeloDocumentoFiscalPage.adicionarModeloDocOper(j.getValor('identrsaidop02'), j.getValor('nmtipooper02'), j.getValor('dsmoddocfisc67'));
        geralPage.clickSalvar();
        geralPage.filterIt(j.getValor('dsmoddocfisc67'));
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc67'), 1)).toBe(j.getValor('dsmoddocfisc67'));
    });

    it('Excluir Modelo de Documento por Operação Saída', () => {
        geralPage.trocarAba('Por Tipo de Operação');
        modeloDocumentoFiscalPage.excluirModeloDocOper(j.getValor('identrsaidop02'), j.getValor('nmtipooper02'));
        geralPage.clickGrid('DSMODDOCFISC', j.getValor('dsmoddocfisc59'), '48606628218783788451034', false);
        geralPage.clickExcluir();
        geralPage.clickSim();
        expect(geralPage.gridHasText('48606628218783788451034', j.getValor('dsmoddocfisc59'), 1, false)).toBeUndefined();
    });
});
